#include <pic.h>
#include <htc.h>
#include "delay.h"

__CONFIG(LVPDIS&BORDIS&PWRTEN&WDTDIS&HS);

void interrupt isr (void); // . . . -  
char Impulse_Lenght;		//   ,   ,    -  .

void main (void)
{
	Impulse_Lenght=32;		//  .
	RBPU=1;		//   Vdd PORTB 0-, 1- (sic!)
	TRISB4=1;		
	TRISB3=0;	//	1,4,5   , 3 -  .    
	TRISB5=1;
	TRISB1=1;

/********CCP   : */
	CCP1M3=1;	//
	CCP1M2=1;	//	11 - PWM
	CCP1M1=1;	//	
	CCP1M0=1;	//

/***	    2. 
		   ,  ,   ****/
	PR2=0x80; 

/***	 . 10 .
		    . 
		255    .
		 -  ,     
		 CCP1Y,        CCP1X,
		     +1  CCPR1L. - .
		 1024   .     
***/
	CCPR1L=Impulse_Lenght;	//. 
	CCP1X=0;	//. 
	CCP1Y=0;	//. XY

/***** TMR2 1:1.      ,   ,   f *****/
T2CKPS1=0;
T2CKPS0=0;
RBIE=1;		//     RB4-RB7 .
RBIF=0;		//  
TMR2ON=1;	// 2,  - 
GIE=1;		//   .
	while(1)
	{
		/*   .   .     .  
		 - ,   */
	}
}
/**************    */

/*		,     RB4-RB7
		,    .      intrerrupt-on-change
		,  
*/
void interrupt isr (void)	//    -   RB4-RB7 - 
{
	RBIE=0;					// 
	if (RB4&&(Impulse_Lenght<PR2)){				//  RB4 ...
			CCPR1L=++Impulse_Lenght;		//   d  1    .      
	}
	else if (RB5&&(Impulse_Lenght>0)){			//  RB5 ...
			CCPR1L=--Impulse_Lenght;		//   d  1    .      
	}
	DelayMs(100);			// 0,1.      
	RBIF = 0;				// 
	RBIE=1;					//  intrerrupt-on-change
}